Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFile.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFile.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFile.java	(revision 5945)
@@ -8,4 +8,7 @@
 import java.net.URL;
 import java.net.URLConnection;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
 
 import org.w3c.dom.Document;
@@ -29,208 +32,268 @@
 public class METSFile
 {
-	METSFileID    id;
-	METSFilePos   location;
-	String        MIMEType;
-	int           sequenceNo;
-	long          size;
-	METSDate      created;
-	long          checkSum;
-	List          adminRefs;
-	List          describeRefs;
-	METSFileGroup group;
-
-	/**
-	 *  Create a new METSFile object, with the given properties.  The remaining
-	 *  fields are filled in with default values.
-	 *
-	 *  @param <code>String</code> the id of the file
-	 *  @param <code>METSFilePos</code> the location of the file
-	 *  @param <code>String</code> the MIME type of the file
-	 */
-	public METSFile(METSFileID id, METSFilePos location, String mimeType)
-	{	this.id           = id;        // required
-		this.location     = location;  // the location
-		this.MIMEType     = mimeType;  // the MIME type;
-		this.sequenceNo   = -1;       // -1 indicates unset
-		this.size         = -1;        // -1 indicates unset
-		this.checkSum     = -1;        // -1 indicates unset
-		this.created      = null;
-		this.adminRefs    = new ArrayList();
-		this.describeRefs = new ArrayList();
-		this.group        = null;
+  METSFileID    id;
+  METSFilePos   location;
+  String        MIMEType;
+  int           sequenceNo;
+  long          size;
+  METSDate      created;
+  long          checkSum;
+  List          adminRefs;
+  List          describeRefs;
+  METSFileGroup group;
+
+  /**
+   *  Create a new METSFile object, with the given properties.  The remaining
+   *  fields are filled in with default values.
+   *
+   *  @param <code>String</code> the id of the file
+   *  @param <code>METSFilePos</code> the location of the file
+   *  @param <code>String</code> the MIME type of the file
+   */
+  public METSFile(METSFileID id, METSFilePos location, String mimeType)
+  { this.id           = id;        // required
+    this.location     = location;  // the location
+    this.MIMEType     = mimeType;  // the MIME type;
+    this.sequenceNo   = -1;       // -1 indicates unset
+    this.size         = -1;        // -1 indicates unset
+    this.checkSum     = -1;        // -1 indicates unset
+    this.created      = null;
+    this.adminRefs    = new ArrayList();
+    this.describeRefs = new ArrayList();
+    this.group        = null;
+  }
+
+  public boolean equals(URL url)
+  { return this.location.equals(url);
+  }
+
+  /**
+   *  Set the parent group
+   *
+   *  @param <code>METSFileGroup</code> the new holding file group
+   */
+  public void setGroup(METSFileGroup group)
+  { this.group = group;
+  }
+
+  /**
+   *  Get the parent group of this file
+   *
+   *  @return <code>METSFileGroup</code> the holding file group
+   */
+  public METSFileGroup getGroup()
+  { return this.group;
+  }
+
+  /**
+   *  Get the identifier of this file
+   *
+   *  @return <code>METSFileID</code> the file identifier
+   */
+  public METSFileID getID()
+  { return this.id;
+  }
+  
+  /**
+   *  Set the identifier of this file
+   *
+   *  @param <code>METSFileID</code> the file identifier
+   */
+  public void setID(METSFileID id)
+  { this.id = id;
+  }
+
+  /**
+   *  @return <code>String</code> the MIME (content) type of the file
+   */
+  public String getMIMEType()
+  { return this.MIMEType;
+  }
+
+  /**
+   *  @return <code>URL</code> the location of the file.  This will often be in
+   *          "file://" form.
+   */
+  public URL getLocation()
+  { return this.location.getLocation();
+  }
+
+  /**
+   *  Take a url and make a METSFile object out of it - works out
+   *  details such as the Mime type, identifiers and other necessary
+   *  information to call the constructor for METSFile
+   *
+   *  @param <code>URL</code> the url of the object - this may be a 
+   *                          reference to a file on the local filestore
+   *
+   *  @return <code>METSFile</code> the METS file object for the corresponding
+   *                                document component.
+   */
+  public static METSFile makeMETSFile(URL url, String mimeType)
+  {	
+    METSFile reply = new METSFile(new METSFileID(), new METSFilePos(url), mimeType);
+    return reply;
+  }
+		
+  public static METSFile makeMETSFile(URL url)
+  { String mimeType;
+  
+    if (url.toString().startsWith("file://"))
+    { // TODO: Work out the MIME type
+      mimeType = URLConnection.getFileNameMap().getContentTypeFor(url.toString().substring(7));
+      if (mimeType == null) 
+      { mimeType = "text/plain";
+      }
+    }
+    else
+    { // TODO: look up the MIME type through the pertinent connection
+      mimeType = HTTPTools.getMIMEType(url);
+    }
+    // TODO: make the identifier...
+    
+    return makeMETSFile(url, mimeType);
+  }
+
+  /**
+   *  Write the METS file in an XML to a text-output sink
+   *
+   *  @param <code>PrintWriter</code> the destination of the output
+   */
+  public void write(PrintWriter writer)
+  { String tag = XMLTools.getOpenTag("mets", "file");
+    tag = XMLTools.addAttribute(tag, "MIMETYPE", this.MIMEType);
+    tag = XMLTools.addAttribute(tag, "ID", this.id.toString());
+    writer.println(tag);
+    
+    tag = XMLTools.getOpenTag("mets", "FLocat");
+    tag = XMLTools.addAttribute(tag, "LOCTYPE", this.location.getType());
+    tag = XMLTools.addAttribute(tag, "xlink:href", this.location.getLocation().toString());
+    tag = XMLTools.addAttribute(tag, "ID", this.id.toString());
+    tag = XMLTools.makeSingleton(tag);
+    writer.println(tag);
+    
+    writer.println(XMLTools.getCloseTag("mets", "file"));
+  }
+
+    
+  public boolean writeSQL(int groupReference, GS3SQLConnection connection)
+  { // check if this file is in the table already...
+    GS3SQLAction action;
+
+    GS3SQLSelect select = new GS3SQLSelect("files");
+    select.addField("*");
+    GS3SQLWhereItem whereItem = new GS3SQLWhereItem("FileGroupRef", "=", Integer.toString(groupReference),
+						    GS3SQLField.INTEGER_TYPE);
+    GS3SQLWhere  where  = new GS3SQLWhere(whereItem);
+    whereItem = new GS3SQLWhereItem("ID","=", this.id.toString());
+    where.add(whereItem);
+    select.setWhere(where);
+    connection.execute(select.toString());
+
+    // if not, then make an insert action
+    try {
+      ResultSet results = connection.getResultSet();
+      if (results == null ||
+	  !results.first())
+      { GS3SQLInsert insert = new GS3SQLInsert("files");
+
+        insert.addValue("FileGroupRef", Integer.toString(groupReference), GS3SQLField.INTEGER_TYPE);
+	insert.addValue("ID", this.id.toString());
+	
+	action = insert;
+	
+      }
+      else {
+	GS3SQLUpdate update = new GS3SQLUpdate("files");
+
+	update.setWhere(where);
+	action = update;
+      }
+    }
+    catch (SQLException ex)
+    { System.err.println(ex);
+      return false;
+    }
+    action.addValue("FileLocType", this.location.getType());
+    action.addValue("FileLocation", this.location.getLocation().toString());
+    action.addValue("MIMEType", this.MIMEType);
+
+    return connection.execute(action.toString());
+  }
+
+  public static METSFile readSQL(GS3SQLConnection connection, ResultSet parentSet)
+  { 
+    try {
+      String locType = parentSet.getString("FileLocType");
+      String location = parentSet.getString("FileLocation");
+      String mimeType = parentSet.getString("MIMEType");
+      String id = parentSet.getString("ID");
+
+      METSFileID metsID = new METSFileID(id);
+      METSFilePos metsFilePos = new METSFilePos(locType, location);
+      
+      METSFile reply = new METSFile(metsID, metsFilePos, mimeType);
+      return reply;
+    }
+    catch (SQLException ex)
+    { System.out.println(ex);
+    }
+    catch (java.net.MalformedURLException urlEx)
+    { System.out.println(urlEx);
+    }
+    return null;
+  }
+    
+  /**
+   *  Parse an XML Element as a METS File
+   */
+  public static METSFile parseXML(Element element, METSFileGroup parentGroup)
+  { METSFile file = null;
+    NodeList children = element.getChildNodes();
+		
+    for (int c = 0; c < children.getLength(); c ++)
+    { if (children.item(c).getNodeType() != org.w3c.dom.Node.ELEMENT_NODE) {
+        continue;
+      }
+    
+      Element childElement = (Element) children.item(c);
+      if (childElement.getNodeName().equals("mets:FLocat"))
+      { METSFilePos filePos;
+    
+        // get most of the information from the child FLocat node
+        String locationType = childElement.getAttribute("LOCTYPE");
+	String href = childElement.getAttribute("xlink:href");
+	String id   = childElement.getAttribute("ID");
+      
+	// some more data from the parent node
+	String mimeType = element.getAttribute("MIMETYPE");
+
+	try 
+	{ filePos = new METSFilePos(href, locationType);
 	}
-
-	/**
-	 *  Set the parent group
-	 *
-	 *  @param <code>METSFileGroup</code> the new holding file group
-	 */
-	public void setGroup(METSFileGroup group)
-	{	this.group = group;
+	catch (java.net.MalformedURLException ex)
+	{ // TODO: raise error
+	  continue;
 	}
-
-	/**
-	 *  Get the parent group of this file
-	 *
-	 *  @return <code>METSFileGroup</code> the holding file group
-	 */
-	public METSFileGroup getGroup()
-	{	return this.group;
-	}
-
-	/**
-	 *  Get the identifier of this file
-	 *
-	 *  @return <code>METSFileID</code> the file identifier
-	 */
-	public METSFileID getID()
-	{	return this.id;
-	}
-
-	/**
-	 *  Set the identifier of this file
-	 *
-	 *  @param <code>METSFileID</code> the file identifier
-	 */
-	public void setID(METSFileID id)
-	{ this.id = id;
-	}
-
-	/**
-	 *  @return <code>String</code> the MIME (content) type of the file
-	 */
-	public String getMIMEType()
-	{	return this.MIMEType;
-	}
-
-	/**
-	 *  @return <code>URL</code> the location of the file.  This will often be in
-	 *          "file://" form.
-	 */
-	public URL getLocation()
-	{	return this.location.getLocation();
-	}
-
-	/**
-	 *  Take a url and make a METSFile object out of it - works out
-	 *  details such as the Mime type, identifiers and other necessary
-	 *  information to call the constructor for METSFile
-	 *
-	 *  @param <code>URL</code> the url of the object - this may be a 
-	 *                          reference to a file on the local filestore
-	 *
-	 *  @return <code>METSFile</code> the METS file object for the corresponding
-	 *                                document component.
-	 */
-	public static METSFile makeMETSFile(URL url, String mimeType)
-	{	
-		METSFile reply = new METSFile(new METSFileID(), new METSFilePos(url), mimeType);
-		return reply;
-	}
-		
-	public static METSFile makeMETSFile(URL url)
-	{ String mimeType;
-
-	  if (url.toString().startsWith("file://"))
-		{ // TODO: Work out the MIME type
-			mimeType = URLConnection.getFileNameMap().getContentTypeFor(url.toString().substring(7));
-			if (mimeType == null) 
-			{ mimeType = "text/plain";
-			}
-		}
-		else
-		{ // TODO: look up the MIME type through the pertinent connection
-			mimeType = HTTPTools.getMIMEType(url);
-		}
-		// TODO: make the identifier...
-
-		return makeMETSFile(url, mimeType);
-	}
-
-	/**
-	 *  Write the METS file in an XML to a text-output sink
-	 *
-	 *  @param <code>PrintWriter</code> the destination of the output
-	 */
-	public void write(PrintWriter writer)
-	{ String tag = XMLTools.getOpenTag("mets", "file");
-		tag = XMLTools.addAttribute(tag, "MIMETYPE", this.MIMEType);
-		tag = XMLTools.addAttribute(tag, "ID", this.id.toString());
-		writer.println(tag);
-
-		tag = XMLTools.getOpenTag("mets", "FLocat");
-		tag = XMLTools.addAttribute(tag, "LOCTYPE", this.location.getType());
-		tag = XMLTools.addAttribute(tag, "xlink:href", this.location.getLocation().toString());
-		tag = XMLTools.addAttribute(tag, "ID", this.id.toString());
-		tag = XMLTools.makeSingleton(tag);
-		writer.println(tag);
-
-		writer.println(XMLTools.getCloseTag("mets", "file"));
-	}
-
-    
-    public void writeSQL(GS3SQLConnection connection)
-    { // check if this node is in the
-	GS3SQLInsert insert = new GS3SQLInsert("files");
-
-	insert.addValue("FileLocType", this.location.getType());
-	insert.addValue("FileLocation", this.location.getLocation().toString());
-	insert.addValue("MIMEType", this.MIMEType);
-	insert.addValue("ID", this.id.toString());
-
-	connection.execute(insert.toString());	
-    }
-    
-	/**
-	 *  Parse an XML Element as a METS File
-	 */
-	public static METSFile parseXML(Element element, METSFileGroup parentGroup)
-	{	METSFile file = null;
-		NodeList children = element.getChildNodes();
-		
-		for (int c = 0; c < children.getLength(); c ++)
-		{ if (children.item(c).getNodeType() != org.w3c.dom.Node.ELEMENT_NODE) {
-				continue;
-			}
-
-			Element childElement = (Element) children.item(c);
-			if (childElement.getNodeName().equals("mets:FLocat"))
-			{	METSFilePos filePos;
-
-				// get most of the information from the child FLocat node
-				String locationType = childElement.getAttribute("LOCTYPE");
-				String href = childElement.getAttribute("xlink:href");
-				String id   = childElement.getAttribute("ID");
-
-				// some more data from the parent node
-				String mimeType = element.getAttribute("MIMETYPE");
-
-				try 
-				{ filePos = new METSFilePos(href, locationType);
-				}
-				catch (java.net.MalformedURLException ex)
-				{ // TODO: raise error
-					continue;
-				}
-				file = new METSFile(new METSFileID(id), filePos, mimeType);
-			}
-			else if (childElement.getNodeName().equals("mets:FContent"))
-			{
-			}
-			else
-			{	// TODO: raise an error!
-			}
-		}
-		return file;
-	}
-
-
-	/**
-	 *  Overridden <code>toString</code> for convenience - returns the location of the file.
-	 *
-	 *  @return <code>String</code> the location of the file as a string
-	 */
-	public String toString()
-	{	return this.location.toString();
-	}
+	file = new METSFile(new METSFileID(id), filePos, mimeType);
+      }
+      else if (childElement.getNodeName().equals("mets:FContent"))
+      {
+      }
+      else
+      { // TODO: raise an error!
+      }
+    }
+    return file;
+  }
+
+
+  /**
+   *  Overridden <code>toString</code> for convenience - returns the location of the file.
+   *
+   *  @return <code>String</code> the location of the file as a string
+   */
+  public String toString()
+  { return this.location.toString();
+  }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileGroup.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileGroup.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileGroup.java	(revision 5945)
@@ -5,4 +5,9 @@
 import java.util.Iterator;
 
+import java.net.URL;
+
+import java.sql.SQLException;
+import java.sql.ResultSet;
+
 import java.io.PrintWriter;
 
@@ -13,4 +18,8 @@
 import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;
 
+/**
+ *  Child groups are indicated by colons.  E.g. Chapter1:Section1 would indicate
+ *  the group "Section1" inside the "Chapter1" group...
+ */
 
 public class METSFileGroup
@@ -19,4 +28,7 @@
   String id;
 
+  public static final String SECTION_PARENT = "Section";
+  public static final String GROUP_PARENT = "Group";
+
   public METSFileGroup(String id)
   { this.children = new ArrayList();
@@ -25,78 +37,140 @@
   }
 
-	/**
-	 *  Add a filegroup to this group of files.
-	 *
-	 *	@param <code>METSFileGroup</code> the filegroup.
-	 */
-	public void addGroup(METSFileGroup group)
-	{	this.childGroups.add(group);
-	}
-
-	/**
-	 *  Add a file to this group of files.
-	 *
-	 *	@param <code>METSFile</code> the file in a METS File object.
-	 */
-	public void addFile(METSFile file)
-	{	this.children.add(file);
-		file.setGroup(this);
-		if (!file.getID().isDefined())
-		{ file.setID(new METSFileID(this.id + Integer.toString(this.children.size())));
-		}
-	}
-
-	/**
-	 *  Get the nth child of the group
-	 *
-	 *  @param <code>int</code> the index into the group
-	 *  @return <code>METSFile</code> the corresponding child.  This may be <code>null</code>
-	 *          particularly if the index given falls outside of the valid range of child
-	 *          indexes.
-	 */
-	public METSFile getFile(int index)
-	{ if (index < 0 || index >= this.children.size())
-		{	return null;
-		}
-
-		return (METSFile) this.children.get(index);
-	}
-
-	/**
-	 *  Get all the files in the group as a <code>List</code>
-	 */
-	public List getFiles()
-	{	return this.children;
-	}
-
-	/**
-	 *  Get all the subgroups as a <code>List</code>
-	 */
-	public List getSubgroups()
-	{	return this.childGroups;
-	}
-
-	/**
-	 *  Get the number of files in the group
-	 *
-	 *  @return <code>int</code> the count
-	 */
-	public int noOfFiles()
-	{	return this.children.size();
-	}
-
-	/**
-	 *  Get the number of subgroups.
-	 */
-	public int noOfSubgroups()
-	{	return this.childGroups.size();
-	}
-
-	/**
-	 *  @return <code>String</code> the name of this group
-	 */
-	public String getName()
-	{	return this.id;
-	}
+  /**
+   *  Find all the occurrences of a given file, and place them
+   *  in a <code>List</code>.
+   */
+  public void findGroups(URL findFile, List resultList)
+  { 
+    // find in this particular group
+    Iterator childIter = children.iterator();
+    while (childIter.hasNext())
+    { METSFile file = (METSFile) childIter.next();
+      if (file.equals(findFile))
+      { resultList.add(this.id);
+      }
+    }
+
+    // iterate over the child groups
+    childIter = childGroups.iterator();
+    while (childIter.hasNext())
+    { METSFileGroup fileGroup = (METSFileGroup) childIter.next();
+
+      fileGroup.findGroups(findFile, resultList);
+    }
+  }
+
+  /**
+   *  Get a sub group of this METSFileGroup.
+   *
+   *  @param <code>String</code> the name of the subgroup
+   *  @return <code>METSFileGroup</code> the child group, which will
+   *          be <code>null</code> if the group is not known.
+   */
+  public METSFileGroup getSubgroup(String id)
+  { String childId;
+  
+    int dotAt = id.indexOf(':');
+    if (dotAt == -1)
+    { childId = null;
+    }
+    else
+    { childId = id.substring(dotAt+1);
+      id = id.substring(0, dotAt);
+    }
+    
+    // iterate over the child groups
+    Iterator childIter = childGroups.iterator();
+    while (childIter.hasNext())
+    { METSFileGroup group = (METSFileGroup) childIter.next();
+    
+      if (group.id.equals(id)) {
+	if (childId == null) {
+	  return group;
+	}
+	else {
+	  return group.getSubgroup(childId);
+	}
+      }
+    }
+    return null;
+  }
+
+  /**
+   *  Add a filegroup to this group of files.
+   *
+   *	@param <code>METSFileGroup</code> the filegroup.
+   */
+  public void addGroup(METSFileGroup group)
+  { this.childGroups.add(group);
+  }
+
+  /**
+   *  Add a file to this group of files.
+   *
+   *	@param <code>METSFile</code> the file in a METS File object.
+   */
+  public void addFile(METSFile file)
+  { this.children.add(file);
+    file.setGroup(this);
+    if (!file.getID().isDefined())
+    { file.setID(new METSFileID(this.id + Integer.toString(this.children.size())));
+    }
+  }
+
+  /**
+   *  Get the nth child of the group
+   *
+   *  @param <code>int</code> the index into the group
+   *  @return <code>METSFile</code> the corresponding child.  This may be <code>null</code>
+   *          particularly if the index given falls outside of the valid range of child
+   *          indexes.
+   */
+  public METSFile getFile(int index)
+  { if (index < 0 || index >= this.children.size())
+    { return null;
+    }
+  
+    return (METSFile) this.children.get(index);
+  }
+
+  /**
+   *  Get all the files in the group as a <code>List</code>
+   *
+   *  @return <code>List</code> the file childen of the group.
+   */
+  public List getFiles()
+  { return this.children;
+  }
+
+  /**
+   *  Get all the subgroups as a <code>List</code>
+   */
+  public List getSubgroups()
+  { return this.childGroups;
+  }
+
+  /**
+   *  Get the number of files in the group
+   *
+   *  @return <code>int</code> the count
+   */
+  public int noOfFiles()
+  { return this.children.size();
+  }
+
+  /**
+   *  Get the number of subgroups.
+   */
+  public int noOfSubgroups()
+  { return this.childGroups.size();
+  }
+
+  /**
+   *  @return <code>String</code> the name of this group
+   */
+  public String getName()
+  { return this.id;
+  }
 
   /**
@@ -118,6 +192,9 @@
   }
 
-  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
-  { // check if this node is in the
+  public boolean writeSQL(DocumentInterface document, String parentRef, boolean parentIsSection, 
+			  GS3SQLConnection connection)
+  { int sqlId = -1;
+
+    // check if this node is in the database already
     GS3SQLSelect select = new GS3SQLSelect("filegroups");
     select.addField("*");
@@ -128,21 +205,135 @@
     select.setWhere(where);
 
-    System.out.println(select.toString());
     connection.execute(select.toString());
 
-    GS3SQLInsert insert = new GS3SQLInsert("filegroups");
-    insert.addValue("DocID", document.getID().toString());
-    insert.addValue("FileGroupID", this.id);
-    insert.addValue("ParentGroup", "");
-    System.out.println("filegroup done");
-    connection.execute(insert.toString());
+    ResultSet selectResult = connection.getResultSet();
+
+    try {
+      if (selectResult == null ||
+	  !selectResult.first()) {
+	GS3SQLInsert insert = new GS3SQLInsert("filegroups");
+
+	insert.addValue("DocID", document.getID().toString());
+	insert.addValue("FileGroupID", this.id);
+	insert.addValue("ParentRef", parentRef, GS3SQLField.INTEGER_TYPE);
+	insert.addValue("ParentType", parentIsSection ? SECTION_PARENT : GROUP_PARENT);
+	
+	if (!connection.execute(insert.toString())) {
+	  return false;
+	}
+      }
+      else {
+	// TODO: update the data for this file group...
+      }
+    }
+    catch (SQLException ex)
+    { System.err.println(ex);
+      return false;
+    }
 		
-    System.out.println("filegroup done");
-
-    Iterator childIter = children.iterator();
+    // get the filegroup reference now
+    connection.execute(select.toString());
+    
+    try {
+      ResultSet results = connection.getResultSet();
+      if (results == null) {
+	return false;
+      }
+      results.first();
+      sqlId = results.getInt("FileGroupRef");
+    }
+    catch (SQLException sqlex) {
+      System.out.println(sqlex);
+      return false;
+    }
+
+    // iterate over the child groups
+    Iterator childIter = childGroups.iterator();
+    while (childIter.hasNext())
+    { METSFileGroup fileGroup = (METSFileGroup) childIter.next();
+
+      if (!fileGroup.writeSQL(document, Integer.toString(sqlId), false, connection))
+      { return false;
+      }
+    }
+
+    // iterate over the child files
+    childIter = children.iterator();
     while (childIter.hasNext())
     { METSFile file = (METSFile) childIter.next();
-      file.writeSQL(connection);
-    }
+    
+      if (!file.writeSQL(sqlId, connection))
+      { return false;
+      }
+    }
+
+    return true;
+  }
+
+  public static METSFileGroup readSQL(DocumentInterface document, GS3SQLConnection connection,
+				      ResultSet resultSet)
+  {
+    try {
+      String ID         = resultSet.getString("FileGroupID");
+      String parentType = resultSet.getString("ParentType");
+      String parentRef  = resultSet.getString("ParentRef");
+
+      // create the metadata block object
+      METSFileGroup group = new METSFileGroup(ID);
+      
+      // get its metadata reference to retrieve divisions
+      int groupRef = resultSet.getInt("FileGroupRef");
+
+      // query the database for matching groups which are children of this one
+      GS3SQLSelect select = new GS3SQLSelect("filegroups");
+      select.addField("*");
+      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("ParentRef", "=", Integer.toString(groupRef),
+						      GS3SQLField.INTEGER_TYPE);
+      GS3SQLWhere where = new GS3SQLWhere(whereItem);
+      whereItem = new GS3SQLWhereItem("ParentType", "=", METSFileGroup.GROUP_PARENT);
+      where.add(whereItem);
+      select.setWhere(where);
+
+      connection.execute(select.toString());
+
+      // parse through the child groups
+      ResultSet childSet = connection.getResultSet();
+      if (childSet.first()) {
+	do {
+	  METSFileGroup fileGroup = METSFileGroup.readSQL(document, connection, childSet);
+	  if (fileGroup != null) {
+	    group.addGroup(fileGroup);
+	  }
+	}
+	while (childSet.next());
+      }
+
+      // now scan for file members
+      select = new GS3SQLSelect("files");
+      select.addField("*");
+      whereItem = new GS3SQLWhereItem("FileGroupRef", "=", Integer.toString(groupRef),
+				      GS3SQLField.INTEGER_TYPE);
+      where = new GS3SQLWhere(whereItem);
+      select.setWhere(where);
+      connection.execute(select.toString());
+
+      ResultSet childFileSet = connection.getResultSet();
+      if (childFileSet != null && childFileSet.first()) {
+	do {
+	  METSFile file = METSFile.readSQL(connection, childFileSet);
+	  if (file != null) {
+	    group.addFile(file);
+	  }
+	}
+	while (childFileSet.next());
+      }
+
+      return group;
+    }
+    catch (SQLException sqlEx)
+    { System.out.println(sqlEx);
+      System.exit(1);
+    }
+    return null;
   }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFilePos.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFilePos.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFilePos.java	(revision 5945)
@@ -6,28 +6,32 @@
 public class METSFilePos
 {
-	METSLocation location;
+  METSLocation location;
 
-	public METSFilePos(File file) throws java.net.MalformedURLException
-	{	this.location = new METSLocation(file);
-	}
+  public METSFilePos(File file) throws java.net.MalformedURLException
+  { this.location = new METSLocation(file);
+  }
 
-	public METSFilePos(URL url)
-	{	this.location = new METSLocation(url);
-	}
+  public METSFilePos(URL url)
+  { this.location = new METSLocation(url);
+  }
 
-	public METSFilePos(String location, String locationType) throws java.net.MalformedURLException
-	{	this.location = new METSLocation(location, locationType);
-	}
+  public METSFilePos(String locationType, String location) throws java.net.MalformedURLException
+  { this.location = new METSLocation(locationType, location);
+  }
+  
+  public URL getLocation()
+  { return this.location.getLocation();
+  }
 
-	public URL getLocation()
-	{	return this.location.getLocation();
-	}
+  public String getType()
+  { return this.location.getType();
+  }
 
-	public String getType()
-	{	return this.location.getType();
-	}
+  public String toString()
+  { return this.location.getLocation().toString();
+  }
 
-	public String toString()
-	{	return this.location.getLocation().toString();
-	}
+  public boolean equals(URL filePos)
+  { return this.location.equals(filePos);
+  }
 }
